/******************************************************************
 *   Copyright(c) 2006,2007 eNtity/Anssi Grhn
 * 
 *   This file is part of GSE.
 *
 *   GSE is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *    GSE is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with GSE; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 ******************************************************************/
/////////////////////////////////////////////////////////////////
#ifndef __GSE_interfaces_h__
#define __GSE_interfaces_h__
/////////////////////////////////////////////////////////////////
/// \brief Interface for Renderers which have multiple 
/// different types of render passes.
template <typename RPT>
class GSE_MultiPassRenderer
{
 protected:

  /// The render pass type
  RPT m_iRenderPassType;
 public:
  ////////////////////
  /// \brief The destructor.
  virtual ~GSE_MultiPassRenderer() {}
  ////////////////////
  /// \brief Sets the render pass.
  /// \param iRenderPass the render pass to be used.
  virtual void SetRenderPass( RPT iRenderPass )
  {
    m_iRenderPassType = iRenderPass;
  }
  ////////////////////
  /// \brief Returns the render pass currently active. 
  /// \return RPT the render pass.
  inline RPT GetRenderPass() 
  {
    return m_iRenderPassType;
  }
};
/////////////////////////////////////////////////////////////////
#endif
/////////////////////////////////////////////////////////////////
