#include <GSE.h>
#include <UnitTest++/UnitTest++.h>

TEST(GraphTest)
{
  GSE_SceneRenderer *pSceneRenderer = new GSE_SceneRenderer();
  GSE_SceneGraph *pSceneGraph = new GSE_SceneGraph();
  pSceneRenderer->SetRenderPass(SCN_RENDER_PASS_DEBUG_PRINT);
  Graph::TravelDF<Scene::NodeType,GSE_SceneRenderer>(pSceneGraph->GetRoot(),
						     pSceneRenderer); 
  
  
  CHECK_EQUAL( (unsigned int)1, pSceneGraph->GetNodeCount());
  GSE_SceneObjectNode *pNode1 = pSceneGraph->CreateNode<GSE_SceneObjectNode>();
  CHECK_EQUAL( (unsigned int)2, pSceneGraph->GetNodeCount());
  GSE_SceneObjectNode *pNode2 = pSceneGraph->CreateNode<GSE_SceneObjectNode>();
  CHECK_EQUAL( (unsigned int)3, pSceneGraph->GetNodeCount());
  CHECK_EQUAL( (unsigned int)0, pSceneGraph->GetEdgeCount());

  pNode1->AddEdge( pNode2 );
  
  CHECK_EQUAL( (unsigned int)1, pSceneGraph->GetEdgeCount());
  pNode1->DeleteEdgeTo( pNode2 );
  CHECK_EQUAL( (unsigned int)0, pSceneGraph->GetEdgeCount());
}


int main()
{
  return UnitTest::RunAllTests();

}
